import { BaseEntity, CreateDateColumn, UpdateDateColumn, ValueTransformer } from 'typeorm';
import * as moment from 'moment';

class CustomTimeTransformer implements ValueTransformer {
  to(value: any): any {
    console.log('🚀 ~ to:', value);
    return moment().utcOffset(0).format('YYYY-MM-DD HH:mm:ss.SSSSSS');
  }

  from(value: any): any {
    return value;
  }
}

export abstract class BaseModel extends BaseEntity {
  @CreateDateColumn({
    type: 'varchar',
    length: 30,
    transformer: new CustomTimeTransformer(),
  })
  created_at: string;

  @UpdateDateColumn({
    type: 'varchar',
    length: 30,
    transformer: new CustomTimeTransformer(),
  })
  updated_at: string;

  @UpdateDateColumn({
    type: 'varchar',
    length: 30,
    transformer: new CustomTimeTransformer(),
  })
  timestamp: string;
}
